local name, addon = ...
local parentName = addon['parentName'] or "BrokerPack"
local childName = "zz_GarrisonToggle"

local defaults = {
}

local options = {
}

local db

local function OnText(message)
	addon['OnText'](childName, message)
end

local function getPref(pref)
	return db[pref[#pref]]
end

local function setPref(pref,value)
	db[pref[#pref]] = value
end
local function toggle(self)
	if (not self:IsShown()) then
		ShowUIPanel(self);
	else
		HideUIPanel(self);
	end
end
local function OnButton(self,button)
	if(not IsAddOnLoaded("Blizzard_GarrisonUI")) then
		UIParentLoadAddOn("Blizzard_GarrisonUI")
	end
	if(button=="LeftButton") then
		toggle(GarrisonLandingPage)
	elseif(button=="RightButton") then
		toggle(GarrisonMissionFrame)
	end
end
local function OnTooltipShow(GameTooltip)
	GameTooltip:AddLine(childName)
	local num = C_Garrison.GetNumFollowers()
	for k,v in pairs(C_Garrison.GetInProgressMissions()) do
		for a,b in pairs(v) do
--			GameTooltip:AddDoubleLine(a,tostring(b))
		end
		GameTooltip:AddDoubleLine(v['name'],v['timeLeft'])
		num = num - v['numFollowers']
	end
	GameTooltip:AddDoubleLine("Follower:",num.."/"..C_Garrison.GetNumFollowers())
	GameTooltip:AddDoubleLine("Missions:",#C_Garrison.GetInProgressMissions().."/"..#C_Garrison.GetAvailableMissions())
end
local function init()
	options = addon['InitConfig'](addon, childName, true, {
		['type'] = "launcher",
		['OnClick'] = OnButton,
		['OnTooltipShow'] = OnTooltipShow,
	}, getPref, setPref)
	db = addon['db']['profile'][childName]
end
addon['startup'](addon, name, childName, init, true, defaults)